System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, input, Input, KeyCode, Vec3, SphereCollider, RigidBody, globalVars, _dec, _class, _crd, ccclass, property, PlayerScript;

  function _reportPossibleCrUseOfglobalVars(extras) {
    _reporterNs.report("globalVars", "./globalVars", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      input = _cc.input;
      Input = _cc.Input;
      KeyCode = _cc.KeyCode;
      Vec3 = _cc.Vec3;
      SphereCollider = _cc.SphereCollider;
      RigidBody = _cc.RigidBody;
    }, function (_unresolved_2) {
      globalVars = _unresolved_2.globalVars;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7730d9GTK1P6YF1wd843uD3", "playerScript", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("PlayerScript", PlayerScript = (_dec = ccclass('PlayerScript'), _dec(_class = class PlayerScript extends Component {
        constructor(...args) {
          super(...args);
          this.movementSpeed = 3;
          this.jumpStrength = 300;
          this.crouch = 0;
          this.moveForward = 0;
          this.moveBackward = 0;
          this.moveLeft = 0;
          this.moveRight = 0;
          this.nodePos = new Vec3();
          this.nodeDeltaPos = new Vec3(0, 0, 0);
          this.setSpeed = 0.12;
          this.maxSpeed = 0;
          this.speed = 1;
          this.grounded = false;
          this.collider = null;
          this.playerHeight = 2;
        }

        /* End Local Variables */
        start() {
          (_crd && globalVars === void 0 ? (_reportPossibleCrUseOfglobalVars({
            error: Error()
          }), globalVars) : globalVars).character = this;
          input.on(Input.EventType.KEY_DOWN, this.onKeyDown, this);
          input.on(Input.EventType.KEY_UP, this.onKeyUp, this);
          this.node.getComponent(SphereCollider).on('onCollisionStay', this.OnCollisionStay, this);
          this.node.getComponent(SphereCollider).on('onCollisionExit', this.OnCollisionExit, this);
          this.node.getComponent(SphereCollider).radius = this.playerHeight;
          this.maxSpeed = this.setSpeed;
        }

        OnCollisionStay(event) {
          event.contacts.forEach(contact => {
            let out = new Vec3();
            contact.getWorldNormalOnB(out);

            if (Vec3.angle(out, Vec3.UP) < 60) {
              this.grounded = true;
            }
          });
        }

        OnCollisionExit() {
          this.grounded = false;
        }

        onKeyDown(event) {
          switch (event.keyCode) {
            case KeyCode.KEY_A:
              {
                this.moveLeft = 1;
                break;
              }

            case KeyCode.KEY_W:
              {
                this.moveForward = 1;
                break;
              }

            case KeyCode.KEY_D:
              {
                this.moveRight = 1;
                break;
              }

            case KeyCode.KEY_S:
              {
                this.moveBackward = 1;
                break;
              }

            case KeyCode.SHIFT_LEFT:
              {
                this.speed = 1.1;
                break;
              }

            case KeyCode.KEY_C:
              {
                if (this.crouch == 0) {
                  this.crouch = 1;
                  this.node.getComponent(RigidBody).clearForces();
                  this.node.getComponent(SphereCollider).radius = this.playerHeight / 1.4;
                  this.maxSpeed = this.setSpeed / 1.4;
                } else if (this.crouch == 1) {
                  this.crouch = 0;
                  this.node.getComponent(SphereCollider).radius = this.playerHeight;
                  this.maxSpeed = this.setSpeed;
                }

                break;
              }

            case KeyCode.SPACE:
              {
                if (this.grounded && this.crouch == 0) {
                  this.node.getComponent(RigidBody).applyLocalForce(new Vec3(0, this.jumpStrength * this.node.getComponent(RigidBody).mass, 0), new Vec3(0, 10, 0));
                }

                break;
              }
          }
        }

        onKeyUp(event) {
          switch (event.keyCode) {
            case KeyCode.KEY_A:
              {
                this.moveLeft = 0;
                break;
              }

            case KeyCode.KEY_W:
              {
                this.moveForward = 0;
                break;
              }

            case KeyCode.KEY_D:
              {
                this.moveRight = 0;
                break;
              }

            case KeyCode.KEY_S:
              {
                this.moveBackward = 0;
                break;
              }

            case KeyCode.SHIFT_LEFT:
              {
                this.speed = 1;
                break;
              }
          }
        }

        update(deltaTime) {
          if (this.moveForward && this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed, 0, -(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveForward && this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed, 0, -(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveBackward && this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed, 0, this.maxSpeed / 4 * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveBackward && this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed, 0, this.maxSpeed / 4 * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveForward) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(0, 0, -(this.maxSpeed * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveBackward) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(0, 0, this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed * this.node.getComponent(RigidBody).mass) * this.speed, 0, 0));
          } else if (this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed * this.node.getComponent(RigidBody).mass * this.speed, 0, 0));
          }
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=2763623fa70956bbca0bda9ef4243d9a26e1176c.js.map