System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, input, Input, KeyCode, Vec3, RigidBody, globalVars, _dec, _class, _crd, ccclass, property, PlayerScript;

  function _reportPossibleCrUseOfglobalVars(extras) {
    _reporterNs.report("globalVars", "./globalVars", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      input = _cc.input;
      Input = _cc.Input;
      KeyCode = _cc.KeyCode;
      Vec3 = _cc.Vec3;
      RigidBody = _cc.RigidBody;
    }, function (_unresolved_2) {
      globalVars = _unresolved_2.globalVars;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7730d9GTK1P6YF1wd843uD3", "playerScript", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("PlayerScript", PlayerScript = (_dec = ccclass('PlayerScript'), _dec(_class = class PlayerScript extends Component {
        constructor() {
          super(...arguments);
          this.movementSpeed = 3;
          this.jumpHeight = 300;
          this.moveForward = 0;
          this.moveBackward = 0;
          this.moveLeft = 0;
          this.moveRight = 0;
          this.nodePos = new Vec3();
          this.nodeDeltaPos = new Vec3(0, 0, 0);
          this.maxSpeed = 0.12;
          this.speed = 1;
        }

        /* End Local Variables */
        start() {
          (_crd && globalVars === void 0 ? (_reportPossibleCrUseOfglobalVars({
            error: Error()
          }), globalVars) : globalVars).character = this;
          input.on(Input.EventType.KEY_DOWN, this.onKeyDown, this);
          input.on(Input.EventType.KEY_UP, this.onKeyUp, this);
        }

        onKeyDown(event) {
          switch (event.keyCode) {
            case KeyCode.KEY_A:
              {
                this.moveLeft = 1;
                break;
              }

            case KeyCode.KEY_W:
              {
                this.moveForward = 1;
                break;
              }

            case KeyCode.KEY_D:
              {
                this.moveRight = 1;
                break;
              }

            case KeyCode.KEY_S:
              {
                this.moveBackward = 1;
                break;
              }

            case KeyCode.SHIFT_LEFT:
              {
                this.speed = 1.2;
                break;
              }

            case KeyCode.SPACE:
              {
                this.node.getComponent(RigidBody).applyLocalForce(new Vec3(0, this.jumpHeight * this.node.getComponent(RigidBody).mass, 0), new Vec3(0, 10, 0));
                break;
              }
          }
        }

        onKeyUp(event) {
          switch (event.keyCode) {
            case KeyCode.KEY_A:
              {
                this.moveLeft = 0;
                break;
              }

            case KeyCode.KEY_W:
              {
                this.moveForward = 0;
                break;
              }

            case KeyCode.KEY_D:
              {
                this.moveRight = 0;
                break;
              }

            case KeyCode.KEY_S:
              {
                this.moveBackward = 0;
                break;
              }

            case KeyCode.SHIFT_LEFT:
              {
                this.speed = 1;
                break;
              }
          }
        }

        update(deltaTime) {
          if (this.moveForward && this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed, 0, -(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveForward && this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed, 0, -(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveBackward && this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass) * this.speed, 0, this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveBackward && this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed, 0, this.maxSpeed / 2 * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveForward) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(0, 0, -(this.maxSpeed * this.node.getComponent(RigidBody).mass) * this.speed));
          } else if (this.moveBackward) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(0, 0, this.maxSpeed * this.node.getComponent(RigidBody).mass * this.speed));
          } else if (this.moveLeft) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(-(this.maxSpeed * this.node.getComponent(RigidBody).mass) * this.speed, 0, 0));
          } else if (this.moveRight) {
            this.node.getComponent(RigidBody).applyLocalImpulse(new Vec3(this.maxSpeed * this.node.getComponent(RigidBody).mass * this.speed, 0, 0));
          }
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=f7919302c7538c0182eb7ffd67401cc84202df03.js.map